var AccvInstaller = {

	extFullName: 'mozAM', //-- El nom que vora l'usuari
	extShortName: 'mozam', //-- El nom del fitxer JAR de l'extensi (sense la part del .jar)
	extVersion: '0.8',
	extAuthor: 'Agencia de Tecnolog\355a y Certificaci\363n Electr\363nica, ACCV',
	extLocaleNames: null, //-- p.e. ['en-US', 'en-GB']
	extSkinNames: null, //-- p.e. ['classic', 'modern']
	extPostInstallMessage: 'Instalaci\363n completada con \351xito! Reinicie el navegador para que los cambios tengan efecto.', //-- Posa null si no vols cap missatge

	profileInstall: true,
	silentInstall: false,

	install: function()
	{
		var jarName = this.extShortName + '.jar';
		var profileDir = Install.getFolder('Profile', 'chrome');

		// Parse HTTP arguments
		this.parseArguments();

		//-- Comprova si l'extensi ja es troba installada
		if (File.exists(Install.getFolder(profileDir, jarName)))
		{
			if (!this.silentInstall)
			{
				Install.alert('Actualizando ' + this.extFullName + ' a al versi\363n ' + this.extVersion + '.');
			}
			this.profileInstall = true;
		}
		else if (!this.silentInstall)
		{
			//-- Demana la confirmaci de l'usuari
			this.profileInstall = Install.confirm('Desea instalar ' + this.extFullName + ' ' + this.extVersion + ' en el directorio de su Perfil (OK) o en el de su Navegador (Cancel)?');
		}

		//-- Inicia la installaci
		var dispName = this.extFullName + ' ' + this.extVersion;
		var regName = '/' + this.extAuthor + '/' + this.extShortName;
		Install.initInstall(dispName, regName, this.extVersion);

		//-- Troba el directori on installar
		var installPath;
		if (this.profileInstall) installPath = profileDir;
		else installPath = Install.getFolder('chrome');

		//-- Afegeix el fitxer JAR
		Install.addFile(null, 'chrome/' + jarName, installPath, null);

		//-- Registra chrome
		var jarPath = Install.getFolder(installPath, jarName);
		var installType = this.profileInstall ? Install.PROFILE_CHROME : Install.DELAYED_CHROME;

		//-- Registra content
		Install.registerChrome(Install.CONTENT | installType, jarPath, 'content/' + this.extShortName + '/');

		//-- Registra locales
		for (var locale in this.extLocaleNames)
		{
			var regPath = 'locale/' + this.extLocaleNames[locale] + '/' + this.extShortName + '/';
			Install.registerChrome(Install.LOCALE | installType, jarPath, regPath);
		}

		//-- Registra skins
		for (var skin in this.extSkinNames)
		{
			var regPath = 'skin/' + this.extSkinNames[skin] + '/' + this.extShortName + '/';
			Install.registerChrome(Install.SKIN | installType, jarPath, regPath);
		}

		//-- Indica com ha estat la installaci
		var err = Install.performInstall();
		if (err == Install.SUCCESS || err == Install.REBOOT_NEEDED)
		{
			if (!this.silentInstall && this.extPostInstallMessage)
			{
				Install.alert(this.extPostInstallMessage);
			}
		}
		else
		{
			this.handleError(err);
			return;
		}
	},

	parseArguments: function()
	{
		// Can't use string handling in install, so use if statement instead
		var args = Install.arguments;
		if (args == 'p=0')
		{
			this.profileInstall = false;
			this.silentInstall = true;
		}
		else if (args == 'p=1')
		{
			this.profileInstall = true;
			this.silentInstall = true;
		}
	},

	handleError: function(err)
	{
		if (!this.silentInstall)
		{
			Install.alert('Error: No ha sido posible realizar la instalaci\363n de la extensi\363n ' + this.extFullName + ' ' + this.extVersion + " (C\363digo de Error: " + err + ')');
		}
		Install.cancelInstall(err);
	}
};

AccvInstaller.install();
